<?php
class CustomCategoryFields {
    private $_prefix;

    public function __construct($prefix) {        
        $this->_prefix  = ($prefix) ? $prefix : 'category';

        add_action('edit_category_form_fields', array($this, 'extra_category_fields'));
        add_action('edited_category', array($this, 'save_extra_category_fileds'));
    }
    
    private function _getTextField($fieldname, $value, $desc) {
        $t = '<input type="text" name="custom_fields[' . $this->_prefix . '][' . $fieldname . ']" id="' . $this->_prefix . '[' . $fieldname . ']" size="3" style="width:60%;" value="' . $value . '"><br />';

        if ($desc != '') {
            $t .= '<span class="description">' . $desc . '</span>';
        }
        
        return $t;
    }

    //add extra fields to category edit form callback function
    function extra_category_fields( $tag ) {    //check for existing featured ID
        $t_id = $tag->term_id;
        $cat_meta = get_option("custom_fields_$t_id");
        $values = $cat_meta[$this->_prefix];
        
        $value_image = $values['image'] ? $values['image'] : '';
        ?>
        <tr class="form-field">
            <th scope="row" valign="top"><label for="cat_Image_url">Image</label></th>
            <td>
                <?php echo $this->_getTextField('image', $value_image, 'Desc...')?>
            </td>
        </tr>
        <?php
    }

    // save extra category extra fields callback function
    public static function save_extra_category_fileds( $term_id ) {
        $data = $_POST['custom_fields'];
        if (isset($data)) {            
            $t_id = $term_id;
            $cat_meta = get_option("custom_fields_$t_id");
            $cat_keys = array_keys($data);
            
            foreach ($cat_keys as $key){
                if (isset($data[$key])){
                    $cat_meta[$key] = $data[$key];
                }
            }

            //save the option array
            update_option("custom_fields_$t_id", $cat_meta );
        }
    }        
} //******* Rom 6: 23 : For the wages of sin is death; but the gift of God is eternal life through Jesus Christ our Lord ******/